
#include <tmstdlib.h>
#include <cpxdata.h>
#include <aes.h>
#include <tos.h>
#include <string.h>
#include <vaproto.h>

#include "xmsg.h"
#include "rsh.h"
#include "bubrsc.h"
#include "proto.h"


#ifdef DEBUG
void DEBUG_IT(char *s, ...)
{
	char buf[128];
	char fmt[128];
	va_list p;
	
	va_start(p,s);
	Vsprintf(buf,s,p);
	Sprintf(fmt,"[1][%s][ OK ]",buf);
	form_alert(1,fmt);
}
#undef DEBUG
#define DEBUG(_a_)  DEBUG_IT _a_  /* UNSAVE Macro !! */
#else
#undef DEBUG
#define DEBUG(_a_)
#endif




#define SET_IT 4567

#define BUBBLEGEM_SHOW 0xBABB
#define BUBBLEGEM_ACK 0xBABC
#define BUBBLE "BUBBLE  "
#define STGUIDE "ST-GUIDE"
#define _COPS	"COPS    "
#define SENDBUBBLE 1
#define SENDGUIDE 0
#define SENDCOPS 2

typedef struct
{	WORD mintime;
} SAVEBLK;

extern SAVEBLK saveblk; /* in cpxstart.s */

#define RAMSTRLEN 80
#define MAXSTR 4
#define RAMSIZE ((LONG)(RAMSTRLEN*MAXSTR))



char __rscid[] = "$Version: BubbleGEM Conf CPX  FREEWARE V 1.00  20.04.97  by ToMST, Thomas Maier $";

#define HELP() send_msg(SENDGUIDE,0,0,"*:\\CPXE.HYP BUBCONF-CPX")

#define COOKIENAME asc2long('B','H','L','P')

XCPB *xcpb;

CPXINFO cpxinfo = { (WORD (*)(GRECT*))cpx_call, NULL, NULL, NULL, cpx_key,
					cpx_button, NULL, NULL, NULL, cpx_close };

OBJECT *bubble;

WORD apl_id;
BOOLEAN Cops = FALSE;
BOOLEAN MultiTOS = FALSE;
void *copsdialog;


#define NUMTIME 7
WORD timem;
char *timemenu[] = { "  0.5 s ",
					 "  1 s   ",
					 "  2 s   ",
					 "  3 s   ",
					 "  4 s   ",
					 "  5 s   ",
					 "  10 s  ",
					NULL };

/****************************************************************************
 *           CPX Funktionen 
 ****************************************************************************/

CPXINFO *cpx_init( XCPB *Xcpb, LONG copsmagic, LONG copsversion )
{	WORD i;

	xcpb = Xcpb;
	
	Cops = (copsmagic == asc2long('C','O','P','S') && copsversion >= 0x10000L );

	if ( xcpb->booting )
	{	Set_Bubble_Cookie();
		return (CPXINFO*)1;
	}
	
	bubble = rs_trindex[OTBUBBLE];
	
	if ( ! xcpb->SkipRshFix )
	{	for ( i = 0; i < NUM_OBJS; i++ )
			cpxrsh_obfix(xcpb,bubble,i);
	}
	
	return &cpxinfo;
}


WORD bevent = 0;

WORD cpx_call( GRECT *work, void *_copsdialog )
{	
	LONG mt;
	
	apl_id = appl_init();
	MultiTOS = (global[0] >= 0x399 && cpxgetcookie(xcpb,asc2long('M','a','g','X'),NULL))
				|| ( global[0] >= 0x400 && (global[1] == -1 || global[1] > 8) );
	
	if ( !Cops )
	{	form_alert(1,"[3][ | BUBCONF.CPX luft nur mit | |      COPS][ OK ]");
		if ( MultiTOS )
			appl_exit();
		return 0;
	}
	
	copsdialog = _copsdialog;
	InitRam();

	bubble[OBACK].ob_x = work->g_x;
	bubble[OBACK].ob_y = work->g_y;
	
	if ( cpxgetcookie(xcpb,COOKIENAME,&mt) )
	{	saveblk.mintime = (ULONG)mt >> 16;
		DEBUG(("Cookie found: %hd",saveblk.mintime));
	}
	else
	{	Set_Bubble_Cookie();
		DEBUG(("Cookie not found: set new one"));
	}
	if ( ! SetMinTime(SET_IT) )
	{	saveblk.mintime = 500;
		SetMinTime(SET_IT);
		Set_Bubble_Cookie();
		DEBUG(("SetMinTime failed"));
	}

	set_evnt_mask();
	/* Damit Objektbaum nicht 2 mal hintereinander gezeichnet wird */
	bubble[ROOT].ob_flags |= HIDETREE;
	wdlg_set_tree(copsdialog,bubble);
	bubble[ROOT].ob_flags &= ~ HIDETREE;
	bevent = wind_set(wdlg_get_handle(copsdialog),WF_BEVENT,1,0,0,0);

	return 1;
}


void cpx_key( WORD kstate, WORD key, WORD *event )
{

	*event = 0;
#define di (kstate & 8)

doitagain:
	switch ( key & 0xff )
	{
	 case 0:	switch ( (key >> 8) & 0xff )
	 			{
	 			 case 98: /* Help */
	 			 				HELP();
	 			 				break;
	 			 				
	 			 case 46: /* ALT C */
	 			 				if (!di) break;
	 			 				key = 127;
	 			 				goto doitagain;
	 			 
	 			 case 31: /* ALT S */
	 			 				if (!di) break;
	 			 				key = 19;
	 			 				goto doitagain;
	 			 				
	 			 case 21: /* ALT Z */
	 			 				if (!di) break;
	 			 				timem++;
	 			 				if ( timem >= NUMTIME ) timem = 0;
	 			 				SetMinTime(timem);
	 			 				break;
	 			}
	 			return;
#undef di
	
	 case 19: /* ^S */
	 			save_defaults();
	 			break;
	 
	 case 17: /* ^Q */
	 case 127: /* Del */
	 case 13:
	 			cpx_close(0);
	 			*event = 1;
	 			break;
	}
}



void cpx_button( MRETS *mrets, WORD nclicks, WORD *event )
{	WORD ret;
	BOOLEAN hlp = mrets->buttons & 2;
	
	*event = 0;
	
	if ( ! (mrets->buttons & 3) )
		return;
	
	if (hlp)
	{	char *s;
#define Help(_s_) s = _s_ ; break
		switch ( ret = objc_find(bubble,OBACK,MAX_DEPTH,mrets->x,mrets->y) )
		{
		 case OCLOSE:	Help("CPX Fenster|schlieen");
		 case OSAVE:	Help("Akt. Einstellung in|CPX-Datei sichern");
		 case OHELP:	Help("Hilfe-Hypertext|anzeigen");
		 case OMZEIT:
		 case OTIME:	Help("Setzt Cookie BHLP sofort|mit der ausgewhlten Einstellung");
		 default:
	 					top_window();
		 				return;
		}
#undef Help(_s_)
		send_msg(SENDBUBBLE,mrets->x,mrets->y,s);
		button_click(2,ret);
		return;
	}
	
	switch ( objc_find(bubble,OBACK,MAX_DEPTH,mrets->x,mrets->y) )
	{
	 case OCLOSE:
	 				if ( button_click(0,OCLOSE) )
	 				{ *event = 1; cpx_close(0); }
	 				break;
	 
	 case OSAVE:
	 				if ( button_click(0,OSAVE) )
	 					save_defaults();
	 				break;
	 
	 case OHELP:
	 				if ( button_click(0,OHELP) )
	 					HELP();
	 				break;

	 case OTIME:
	 				SetMinTime(Popup(OTIME,timemenu,NUMTIME,timem));
	 				break;	 
	 default:
 					top_window();
	 				break;
	}
}


void cpx_close(WORD flag)
{
	FreeRam();
	if ( MultiTOS )
		appl_exit();
}


void top_window(void)
{	static WORD msg[8] = { WM_TOPPED, 0, 0, 0, 0, 0, 0, 0 };
	if ( !bevent) return;
	msg[1] = apl_id;
	msg[3] = wdlg_get_handle(copsdialog);
	appl_write(apl_id,16,msg);
}

/* Behandelt einen Mausklick auf einen Button */
WORD button_click(WORD mode, WORD obj )
{	WORD x,y,b,i;
	if ( mode == 0 )
	{	bubble[obj].ob_state ^= SELECTED;
		redraw(NULL,obj);
	}
	for (;;)
	{	graf_mkstate(&x,&y,&b,&i);
		if ( ! (b & 3) )
		{	i = 1;
			break;
		}
		if ( obj != objc_find(bubble,OBACK,MAX_DEPTH,x,y) )
		{	i = 0;
			break;
		}
	}
	if ( mode == 0 )
	{	bubble[obj].ob_state ^= SELECTED;
		redraw(NULL,obj);
	}
	return i;
}
		
/* Zeigt Popup an */
WORD Popup(WORD obj,char *menu[],WORD numitems,WORD start)
{	GRECT box;

	objc_offset(bubble,obj,&box.g_x,&box.g_y);
	box.g_w = bubble[obj].ob_width;
	box.g_h = bubble[obj].ob_height;
	return cpxPopup(xcpb,menu,numitems,start,IBM,&box,(GRECT*)&bubble[OBACK].ob_x);
}


void redraw( GRECT *clip, WORD obj )
{
	GRECT *win;
	
	if ( ! clip )
		clip = (GRECT*)&bubble[ROOT].ob_x;
	wind_update(BEG_UPDATE);
	win = cpxGetFirstRect(xcpb,clip);
	while (win)
	{	if ( win->g_w == 0 && win->g_h == 0 )
			break;
		objc_draw(bubble,obj,MAX_DEPTH,win->g_x,win->g_y,win->g_w,win->g_h);
		win = cpxGetNextRect(xcpb);
	}
	wind_update(END_UPDATE);
}



/***************************************************************/

COOKIEJAR *__get_cookiejar(void)
{
	return (*_p_cookies);
}

void Set_Bubble_Cookie(void)
{
	COOKIEJAR *jar = (COOKIEJAR *)Supexec((void*)__get_cookiejar);
	
	if ( ! jar )
		return;
	for (;;)
	{	if ( jar->cookie == 0L )
		{	jar->cookie = COOKIENAME;
			(jar+1)->value = jar->value;
			(jar+1)->cookie = 0L;
			jar->value = ((LONG)saveblk.mintime << 16) | 0xffffL;
			return;
		}
		if ( jar->cookie == COOKIENAME )
		{	*(WORD *)&(jar->value) = saveblk.mintime;
			return;
		}
		jar++;
	}
}


WORD SetMinTime(WORD t)
{
	 if ( t == SET_IT )
	 {	switch ( saveblk.mintime )
	 	{
	 	 case 500:	timem = 0; break;
	 	 case 1000: timem = 1; break;
	 	 case 2000: timem = 2; break;
	 	 case 3000: timem = 3; break;
	 	 case 4000: timem = 4; break;
	 	 case 5000: timem = 5; break;
	 	 case 10000: timem = 6; break;
	 	 default:	return 0;
	 	}
	}
	else
	{	
		switch ( t )
		{
		 case 0:	saveblk.mintime = 500; break;
		 case 1:	saveblk.mintime = 1000; break;
		 case 2:	saveblk.mintime = 2000; break;
		 case 3:	saveblk.mintime = 3000; break;
		 case 4:	saveblk.mintime = 4000; break;
		 case 5:	saveblk.mintime = 5000; break;
		 case 6:	saveblk.mintime = 10000; break;
		 default:	return 0;
		}
		timem = t;
	}

	bubble[OTIME].ob_spec.free_string = timemenu[timem];
	if ( t != SET_IT )
	{	redraw(NULL,OTIME);
		Set_Bubble_Cookie();
	}
	return 1;
}

void send_msg(WORD mode,WORD x,WORD y, char *s)
{	WORD msg[8+8+RAMSTRLEN/2+2], *mp;
	WORD xmsg_id, len;
	char *p;
	extern void *ram;
	extern WORD cram;
	
	if ( (xmsg_id = appl_find("XMSG    ")) < 0 )
	{
		if ( ram == NULL )
			return;
		if ( cram >= MAXSTR )  cram = 0;
		p = (char*)ram + RAMSTRLEN * cram;
	}
	else p = (char*)&msg[16];
	
	if ( mode == SENDBUBBLE )
	{	if ( (msg[3] = appl_find(BUBBLE)) < 0 )
			return;
		msg[4] = 5;
		msg[8] = BUBBLEGEM_SHOW;
		msg[11] = x;
		msg[12] = y;
		*(char**)&msg[13] = (xmsg_id >= 0 ? (char*)16L : p );
	}
	else
	{	if ( (msg[3] = appl_find(mode == SENDCOPS ? _COPS : STGUIDE)) < 0 )
			return;
		msg[4] = 3;
		msg[8] = VA_START;
		*(char**)&msg[11] = (xmsg_id >= 0 ? (char*)16L : p );
		msg[13] = 0;
		msg[14] = 0;
	}
	msg[10] = 0;
	msg[15] = 0;
	
	if ( xmsg_id >= 0 )
	{	len = 16 + 1 + strlen(s);
		if ( len > (RAMSTRLEN + 16) )
			len = RAMSTRLEN + 16;
		msg[0] = XMESSAGE;
		msg[1] = xmsg_id; /* Damit AV_STARTED etc. nicht an COPS gesendet wird */
		msg[2] = len;
		msg[5] = -1;
		msg[6] = 0;
		msg[7] = 0;
		msg[9] = xmsg_id;
		mp = msg;
	}
	else
	{	cram++;
		mp = &msg[8];
		len = 0;
		msg[9] = apl_id;
		xmsg_id = msg[3];
	}
	
	strncpy(p,s,RAMSTRLEN-1);
	p[RAMSTRLEN-1] = 0;
	appl_write(xmsg_id,16+len,mp);
}



void save_defaults(void)
{
	if ( cpxXGen_Alert(xcpb,SAVE_DEFAULTS) )
		cpxCPX_Save(xcpb,(void*)&saveblk,sizeof(saveblk));
}


WORD cram = 0;
void *ram = NULL;

void InitRam(void)
{
	if ( ram == NULL )
	{	if ( cpxgetcookie(xcpb,asc2long('M','i','N','T'),NULL)
				|| cpxgetcookie(xcpb,asc2long('M','a','g','X'),NULL) )
			ram = Mxalloc(RAMSIZE,0x20+3);
		else
			ram = Malloc(RAMSIZE);
	}
}

void FreeRam(void)
{	if ( ram )
		Mfree(ram);
}

void set_evnt_mask(void)
{	static MOBLK dummymoblk;
	cpxSet_Evnt_Mask(xcpb,MU_BUTTON|MU_KEYBD,
					&dummymoblk,&dummymoblk,0);
}


