
#include <tm_start.h>
#include <tmstdlib.h>
#include <aes.h>
#include <mint_tos.h>
#include <string.h>

#include "cpxetrsc.h"
#include "rsh.h"
#include "proto.h"

#include "cpxetime.h"


#ifdef DEBUG
void DEBUG_IT(char *s, ...)
{
	char buf[128];
	char fmt[128];
	va_list p;
	
	va_start(p,s);
	Vsprintf(buf,s,p);
	Sprintf(fmt,"[1][%s][ OK ]",buf);
	form_alert(1,fmt);
}
#undef DEBUG
#define DEBUG(_a_)  DEBUG_IT _a_  /* UNSAVE Macro !! */
#else
#undef DEBUG
#define DEBUG(_a_)
#endif



#define CPXETIMERNAME "CPXETIME"
#define CPXETIMERMENUNAME "  CPXEtimer V 0.01"


char __rscid[] = "$Version: CPXEtimer FREEWARE Testversion 0.01  25.03.97 by ToMST Thomas Maier $";

void Info(void)
{
	form_alert(1,"[1][  *** CPXEtimer ***   |   Timeremulation|  Testversion 0.01|"
				 " 25.03.97 by ToMST|  +++ FREEWARE +++][ OK ]");
}



WORD aplid;
WORD menuid;

OBJECT *menutree;

extern WORD _app;

struct
{
	struct multitoskonstanten
	{	unsigned ok : 1; /* ein AES >=4.00 ist vorhanden */
		unsigned applread_1 : 1; /* appl_read(-1,..) */
		unsigned apterm		: 1; /* Shutdown-Mglichkeit */
		unsigned search     : 1; /* appl_search vorhanden */
	}		mtos;
	WORD	aesversion;
}  AMc;

WORD sigexit = 0;


void sigh(LONG sig)
{
	switch ((WORD)sig)
	{
	 case SIGHUP:
	 case SIGINT:
	 case SIGQUIT:
	 case SIGTERM:
	 case SIGABRT:
	 case SIGXCPU:
	 				sigexit = 1;
	 				Psignal((WORD)sig,SIG_IGN);
	 				break;
	}
}

void signal_init(void)
{
	if ( Psignal(SIGTERM,sigh) != EINVFN )
	{	Psignal(SIGINT,sigh);
		Psignal(SIGQUIT,sigh);
		Psignal(SIGABRT,sigh);
		Psignal(SIGSYS,SIG_IGN);
		Psignal(SIGPIPE,SIG_IGN);
		Psignal(SIGALRM,SIG_IGN);
		Psignal(SIGHUP,sigh);
		Psignal(SIGURG,SIG_IGN);
		Psignal(SIGSTOP,SIG_IGN);
		Psignal(SIGTSTP,SIG_IGN);
		Psignal(SIGTTIN,SIG_IGN);
		Psignal(SIGTTOU,SIG_IGN);
		Psignal(SIGIO,SIG_IGN);
		Psignal(SIGXCPU,sigh);
		Psignal(SIGXFSZ,SIG_IGN);
		Psignal(SIGVTALRM,SIG_IGN);
		Psignal(SIGPROF,SIG_IGN);
		Psignal(SIGUSR1,SIG_IGN);
		Psignal(SIGUSR2,SIG_IGN);
	}
}


typedef struct
{
	WORD	aid; /*  -1  free block */
	WORD	wid;
	WORD	time;
	WORD	count;
} WINFO;

#define MAXITEMS 8
#define BUFLEN ((LONG)sizeof(WINFO) * MAXITEMS)

WINFO buffer[MAXITEMS];



WORD SendMsg(WORD to, WORD from, WORD msgnr, ... )
{	WORD msg[8];
	va_list p;

	va_start(p,msgnr);
	msg[0] = msgnr;
	msg[1] = from;
	msg[2] = 0;
	msg[3] = va_arg(p,WORD);
	msg[4] = va_arg(p,WORD);
	msg[5] = va_arg(p,WORD);
	msg[6] = va_arg(p,WORD);
	msg[7] = va_arg(p,WORD);
	
	return appl_write(to,16,msg);
}



void mtosinit(void)
{	WORD w1,w2,w3,w4,i,magx;
	
	AMc.aesversion = global[0];
	AMc.mtos.ok = (global[0] >= 0x400 );
	magx = ( global[0] == 0x0399 && Get_cookie(asc2long('M','a','g','X'),NULL) );
	if ( magx || AMc.mtos.ok )
	{	i = appl_getinfo(4,&w1,&w2,&w3,&w4);
		AMc.mtos.search = ( i ? w3 != 0 : AMc.mtos.ok );
		i = appl_getinfo(6,&w1,&w2,&w3,&w4);
		AMc.mtos.applread_1 = ( i ? w1 != 0 : AMc.mtos.ok );
		i = appl_getinfo(10,&w1,&w2,&w3,&w4);
		AMc.mtos.apterm = ( i ? (w1 & 0xff)>=9 : AMc.mtos.ok );
	}
	AMc.mtos.ok = ( AMc.mtos.ok || magx );
}

#define STRINGLEN 256

void cancel_msg_2( WORD msg[8] )
{	WORD tmp[STRINGLEN], i;

	if ( msg == NULL ) return;
	while (msg[2] > 0 )
	{	if ( msg[2] > STRINGLEN ) i = STRINGLEN; else i = msg[2];
		msg[2] -= i;
		if ( !appl_read((AMc.mtos.applread_1 ? -1 : aplid),i,tmp) )
			msg[2] = 0;
	}
}


void cancel_dragdrop(WORD msg[8])
{	static char pipename[] = "U:\\PIPE\\DRAGDROP.AA";
	LONG fd;
	register char *mem = (char *)&msg[7];
	BYTE c;
	
#define DD_NAK 1

	pipename[17] = *mem++;
	pipename[18] = *mem;
	fd = Fopen(pipename,O_RDWR);
	if ( fd > 0 )
	{	c = DD_NAK;
		Fwrite((WORD)fd,1L,&c);
		Fclose((WORD)fd);
	}
}



void Exit(WORD ok)
{
	if ( _app || AMc.mtos.ok)
	{	if (menutree)
			menu_bar(menutree,0);
		appl_exit();
		exit(ok);
	}
	for (;;)
	{	WORD msg[8];
		evnt_mesag(msg);
		cancel_msg_2(msg);
	}
}



void is_running(void)
{
	char buf[16];
	WORD id,a,k;
	
	if ( ! AMc.mtos.search )
		return;
	k = 0;
	while ( appl_search(k,buf,&a,&id) )
	{	k = 1;
		if ( id == aplid )
			continue;
		if ( strncmp(buf,CPXETIMERNAME,8) == 0 )
			Exit(2);
	}
}


void main(void)
{
	menutree = NULL;
	
	aplid = appl_init();
	mtosinit();
	if ( _app || AMc.mtos.ok )
		signal_init();
	
	is_running();
	
	menuid = (AMc.mtos.ok || !_app) ?
				menu_register(aplid,CPXETIMERMENUNAME) : -1;
	if ( AMc.mtos.apterm )
		shel_write(9,1,0,NULL,NULL);
	if ( _app )
	{	WORD i;
		menutree = rs_trindex[OTMENU];
		for ( i = 0; i < NUM_OBJS; i++ )
			rsrc_obfix(menutree,i);
		menu_bar(menutree,1);	
		graf_mouse(ARROW,NULL);
	}
	
	ProcessIt();
	
	Exit(0);
}



void ProcessIt(void)
{
	static WORD msg[8];
	WORD i,k;
	WINFO *b;
	static MEVENT evnt = { MU_TIMER|MU_MESAG,0,0,0,0,{0,0,0,0},0,{0,0,0,0},
					 		msg,1000UL };
	WORD items = 0;
	ULONG time = 1000UL;
	
	for ( i = 0, b = buffer; i < MAXITEMS; i++, b++ )
		b->aid = -1;
	
	for (;;)
	{	evnt.e_time = time;
		k = evnt_event(&evnt);
		if ( k & MU_TIMER )
		{	if ( sigexit )
				Exit(0);
			if ( items <= 0 )
				time = 1000UL;
			else
			{	WORD wtop,x,y,w,h,ret;
			
				wind_get_w(0,WF_TOP,&wtop);
				DEBUG(("write: wtop = %hd",wtop));
				
				time = 400UL;
				for ( i = 0, b = buffer; i < MAXITEMS; i++, b++ )
				{	if ( b->aid >= 0 )
					{	DEBUG(("found: %hd",b->aid));
						if ( b->wid == wtop )
						{	b->count = b->time; continue; }
						/* Existiert Fenster ? */
						ret = wind_get(b->wid,WF_WORKXYWH,&x,&y,&w,&h);
						if ( ret == 0 )
							goto delete_it;
						DEBUG(("window: %hd,%hd,%hd,%hd",x,y,w,h));
						if ( w > 0 && h > 0 )
						{	b->count -= time;
							if ( b->count <= 0 )
							{	DEBUG(("Send It to %hd with %hd",b->aid,b->wid));
								b->count = b->time;
								wind_update(BEG_UPDATE);
								ret = SendMsg(b->aid,aplid,WM_REDRAW,b->wid,x,y,1,1);
								wind_update(END_UPDATE);
								if ( ret == 0 )
								{
								 delete_it:
								 	b->aid = -1;
								 	DEBUG(("delete it"));
								}
							}
						}
					}
				}
			}
		}
		if ( k & MU_MESAG )
		{
			cancel_msg_2(msg);
			switch ( msg[0] )
			{
			 case CPXETIMER_SET:
			 				for ( i = 0, b = buffer; i < MAXITEMS; i++, b++ )
			 				{	if ( b->aid == msg[1] && b->wid == msg[3] )
			 					{	b->time = b->count = msg[4];
			 						DEBUG(("install %hd with %hd,%hd",msg[1],msg[3],msg[4]));
			 						break;
			 					}
			 				}
			 				if ( i < MAXITEMS )
			 					break;
							for ( i = 0, b = buffer; i < MAXITEMS; i++, b++ )
							{	if ( b->aid < 0 )
								{	b->aid = msg[1];
									b->wid = msg[3];
									b->time = msg[4];
									b->count = msg[4];
									items++;
									DEBUG(("install %hd with %hd,%hd",msg[1],msg[3],msg[4]));
									break;
								}
							}
							break;
			 
			 case CPXETIMER_UNSET:
			 				for ( i = 0, b = buffer; i < MAXITEMS; i++, b++ )
			 				{	if ( b->aid == msg[1] && b->wid == msg[3] )
			 					{	b->aid = -1;
			 						items--;
			 						DEBUG(("deinstall %hd with %hd",msg[1],msg[3]));
			 						break;
			 					}
			 				}
			 				break;
										 
			 case AP_TERM:	if (_app) Exit(0); break;
			 
			 case AC_OPEN:	if ( !_app ) Info(); break;
			 
			 case MN_SELECTED:
			 				if ( _app )
			 				{
			 					switch ( msg[4] )
			 					{
			 					 case OINFO:	Info(); break;
			 					 case OQUIT:	Exit(0); break;
			 					}
			 					menu_tnormal(menutree,msg[3],1);
			 				}
			 				break;
			
			 case AP_DRAGDROP:	cancel_dragdrop(msg); break;
			}
		}
	}
}

