
#include <tmstdlib.h>
#include <cpxdata.h>
#include <aes.h>
#include <string.h>
#include <vaproto.h>
#include <tos.h>

#include "resource.h"
#include "galx-rsc.h"
#include "galaxy.h"
#include "proto.h"

#include "xmsg.h"
#include "cpxetime.h"


char __rscid[] = " $Version: GALAXY CPX  FREEWARE V 1.00 20.04.97  by ToMST, Thomas Maier $ ";

#define HELP() send_msg(SENDGUIDE,0,0,"*:\\CPXE.HYP GALAXY-CPX")
#define INITMAGIC asc2long('G','a','l','x')


XCPB *xcpb;
CPXINFO cpxinfo = { (WORD (*)(GRECT*))cpx_call, cpx_draw, cpx_wmove, cpx_timer, cpx_key,
					cpx_button, NULL, NULL, NULL, cpx_close };


WORD apl_id;

OBJECT *info;

BOOLEAN Cops = FALSE;
BOOLEAN MultiTOS = FALSE;
BOOLEAN mtos = FALSE, magx = FALSE;
BOOLEAN isinfodialog = FALSE;
void *copsdialog;
OBJECT dtree = { -1,-1,-1,G_IBOX,LASTOB,0,{0L},0,0,1,1};


#define NUMREFRESH 5
WORD refm = 1;
char *refmenu[] = { "  100 ms  ",
					"  250 ms  ",
					"  500 ms  ",
					"  750 ms  ",
					"  1000 ms ",
					NULL };




#define RAMSTRLEN 80
#define MAXSTR 4
#define RAMSIZE ((LONG)(RAMSTRLEN*MAXSTR))
WORD cram = 0;
void *ram = NULL;

void InitRam(void)
{
	if ( ram == NULL )
	{	if ( cpxgetcookie(xcpb,asc2long('M','i','N','T'),NULL)
				|| cpxgetcookie(xcpb,asc2long('M','a','g','X'),NULL) )
			ram = Mxalloc(RAMSIZE,0x20+3);
		else
			ram = Malloc(RAMSIZE);
	}
}

void FreeRam(void)
{	if ( ram )
		Mfree(ram);
}




/****************************************************************************
 *           CPX Funktionen 
 ****************************************************************************/

SAVEBLK *saveblk;
BOOLEAN xobj;

CPXINFO *cpx_init( XCPB *Xcpb, LONG copsmagic, LONG copsversion )
{	LONG *p;

	xcpb = Xcpb;
	
	Cops = ( copsmagic == asc2long('C','O','P','S') && copsversion >= 0x10000L );
	
	if ( xcpb->booting )
		return (CPXINFO*)1;

	p = (LONG*)cpxGet_Buffer(xcpb);
	saveblk = (SAVEBLK*)(p+1);
	if ( *p != INITMAGIC )
	{	*saveblk = initdata;
		*p = INITMAGIC;
	}

	if ( ! xcpb->SkipRshFix )
		InitGalaxy();
	return &cpxinfo;
}

WORD bevent;

WORD cpx_call( GRECT *work, void *_copsdialog )
{
	apl_id = appl_init();
	magx = (global[0] >= 0x399 && cpxgetcookie(xcpb,asc2long('M','a','g','X'),NULL));
	mtos = ( global[0] >= 0x400 && (global[1] == -1 || global[1] > 8) );
	MultiTOS = mtos || magx;
	
	if ( !Cops )
	{	form_alert(1,"[3][ | GALAXY.CPX luft nur mit | |      COPS][ OK ]");
		if ( MultiTOS )
			appl_exit();
		return 0;
	}
	
	InitRam();
	
	copsdialog = _copsdialog;
	galx[ROOT].ob_x = work->g_x;
	galx[ROOT].ob_y = work->g_y;
	cpobjcpos(dtree,galx[ROOT]);
	
	isinfodialog = FALSE;
	InitObjects();
	set_evnt_mask();
	send_msg(SENDCPXET_SET,0,0,NULL);
	wdlg_set_tree(copsdialog,&dtree);
	
	bevent = wind_set(wdlg_get_handle(copsdialog),WF_BEVENT,1,0,0,0);

	return 1; /* weitermachen */
}




void cpx_draw( GRECT *clip )
{	
	/* CPXEtimer Untersttzung */
	if ( ! isinfodialog )
	{	if ( galx[ROOT].ob_x == clip->g_x && galx[ROOT].ob_y == clip->g_y
				&& clip->g_w == 1 && clip->g_h == 1 )
		{	WORD event;
			cpx_timer(&event);
			return;
		}
	}
	
	redraw(clip,isinfodialog ? info:galx,0);
}



void cpx_wmove( GRECT *work )
{
	info[OINFO].ob_x = work->g_x;
	info[OINFO].ob_y = work->g_y;
	galx[ROOT].ob_x = work->g_x;
	galx[ROOT].ob_y = work->g_y;
}




void cpx_timer( WORD *event )
{
	if ( !isinfodialog )
	{	
		calc();
		redraw(NULL,galx,ROOT);
	}
	*event = 0;
}



void cpx_key( WORD kstate, WORD key, WORD *event )
{
	BOOLEAN di = isinfodialog && (kstate & 8);
#define nodialoginput() (! di)

	*event = 0;

doitagain:
	switch ( key & 0xff )
	{
	 case 0:	switch ( (key >> 8) & 0xff )
	 			{
	 			 case 98: /* Help */
	 			 				HELP();
	 			 				break;
	 			 				
	 			 case 97: /* Undo */
	 			 				if ( isinfodialog)
	 								switch_to_galaxy();
	 							else
	 								switch_to_info();
	 							break;
	 			 
	 			 case 19: /* ALT R */
	 			 				if ( ! nodialoginput() )
	 			 				{	refm++;
	 			 					if ( refm >= NUMREFRESH )
	 			 						refm = 0;
	 			 					set_refresh(refm);
	 			 					redraw(NULL,info,OREFRESH);
	 			 				}
	 			 				break;
	 			 
	 			 case 17: /* ALT W */
	 			 				if ( nodialoginput() )
	 			 					break;
	 			 				key = 13;
	 			 				goto doitagain;
	 			 
	 			 case 46: /* ALT C */
	 			 				if ( nodialoginput() )
	 			 					break;
	 			 				key = 127;
	 			 				goto doitagain;
	 			 
	 			 case 31: /* ALT S */
	 			 				if ( nodialoginput() )
	 			 					break;
	 			 				key = 19;
	 			 				goto doitagain;

	 			}
	 			return;
	
	 case 19: /* ^S */
	 			save_defaults();
	 			break;
	 
	 case 17: /* ^Q */
	 case 127: /* Del */
	 			cpx_close(0);
	 			*event = 1;
	 			break;
	 
	 case 9: /* ^I */
	 			if ( !isinfodialog) switch_to_info();
	 			break;
	 
	 case 13:
	 			if ( isinfodialog)
	 				switch_to_galaxy();
	 			break;
	}
}



void cpx_button( MRETS *mrets, WORD nclicks, WORD *event )
{	WORD ret;
	BOOLEAN hlp = mrets->buttons & 2;
	
	*event = 0;
	
	if ( ! (mrets->buttons & 3) )
		return;
	
	if ( ! isinfodialog )
	{
#define NUMEMENU 5
		static char *emenu[] = { "  Toppen        ",
								 "  Info       ^I ",
								 "  Refreshrate   ",
								 "  Sichern    ^S ",
								 "  Schlieen  ^Q ",
								 NULL };
	
		if ( hlp )
		{	switch_to_info();
			return;
		}
		if ( nclicks > 1 )
		{	top_window();
			return;
		}
		
		switch ( ePopup(emenu,NUMEMENU,-1) )
		{
		 case 0:	top_window(); break;
		 
		 case 1:	switch_to_info(); break;
		 
		 case 2:	set_refresh(ePopup(refmenu,NUMREFRESH,refm));
		 			send_msg(SENDCPXET_SET,0,0,NULL);
					break;
		 
		 case 3:	save_defaults(); break;
		 
		 case 4:	cpx_close(0); *event = 1; break;
		
		}
		
		return;
	}

	if (hlp)
	{	char *s;
		
#define Help(_s_) s = _s_ ; break
		switch ( ret = objc_find(info,OINFO,MAX_DEPTH,mrets->x,mrets->y) )
		{
		 case OGOON:	Help("Weiter zur|Animation");
		 case OCLOSE:	Help("CPX-Fenster|schlieen");
		 case OSAVE:	Help("Akt. Einstellung in|CPX-Datei sichern");
		 case OHELP:	Help("Hilfe-Hypertext|anzeigen");
		 case ORX:
		 case OREFRESH: Help("Zeitdauer zwischen|2 Animationsredraws");
		 default:
	 					top_window();
		 				return;
		}
#undef Help(_s_)
		send_msg(SENDBUBBLE,mrets->x,mrets->y,s);
		button_click(2,ret);
		return;
	}


	switch ( objc_find(info,OINFO,MAX_DEPTH,mrets->x,mrets->y) )
	{
	 case OGOON:
	 				if ( button_click(0,OGOON) ) switch_to_galaxy();
	 				break;
	 
	 case OCLOSE:
	 				if ( button_click(0,OCLOSE) )
	 				{ *event = 1; cpx_close(0); }
	 				break;
	 
	 case OSAVE:
	 				if ( button_click(0,OSAVE) )
	 					save_defaults();
	 				break;
	 
	 case OHELP:
	 				if ( button_click(0,OHELP) )
	 					HELP();
	 				break;
	 
	 case OREFRESH:
		 			set_refresh(Popup(OREFRESH,refmenu,NUMREFRESH,refm));
					redraw(NULL,info,OREFRESH);
					break;
					
	 default:			
 					top_window();
	 				break;
	}
}


void cpx_close(WORD flag)
{
	send_msg(SENDCPXET_UNSET,0,0,NULL);
	FreeRam();
	if ( MultiTOS )
		appl_exit();
}




/*-------------------------------*/

void calc(void)
{
	static WORD phi = 0; /* in 2er Schritten , erst sin, das cos */
	WORD i;
	WORD x,y;
	WORD bw_w = bild_w / 16;
	
	/* x' = cos(phi) * x - sin(phi) * y
	   y' = - sin(phi) * x - cos(phi) * y */
	
	for ( i = 0; i < (bw_w * bild_h); i++ )
		image[i] = 0;
	
	for ( i = 0; i < (num_stars * 2); i += 2 )
	{	x = ( (LONG)sintab[phi+1] * stars[i] - (LONG)sintab[phi] * stars[i+1]) / MATHOFFSET;
		y = (- (LONG)sintab[phi] * stars[i] - (LONG)sintab[phi+1] * stars[i+1]) / MATHOFFSET;
		y /= 2;
	
		x += bild_w / 2;
		y += bild_h / 2;
		if ( x < 0 || y < 0 || x >= bild_w || y >= bild_h )
			continue;
		image[y*bw_w + (x / 16)] |= ((UWORD)0x8000 >> (x & 0xf));
	}
	
	phi += 2;
	if ( phi >= 360*2/SINSTEP )
		phi = 0;
	
}

void set_evnt_mask(void)
{	static MOBLK dummymoblk;
	cpxSet_Evnt_Mask(xcpb,MU_TIMER|MU_BUTTON|MU_KEYBD,
					&dummymoblk,&dummymoblk,saveblk->time);
}

void save_defaults(void)
{
	if ( cpxXGen_Alert(xcpb,SAVE_DEFAULTS) )
		cpxCPX_Save(xcpb,(void*)saveblk,sizeof(*saveblk));
}

void InitObjects(void)
{	WORD i,k;

	if ( appl_getinfo(13,&i,&i,&i,&k) && (k & 4) ) /* WHITEBACK steuert Objekte */
	{
		info[ORTIME].ob_spec.free_string = " Optionen ";
		info[ORTIME].ob_type = G_BUTTON;
		info[ORTIME].ob_state = 0xfe00|WHITEBAK;
		info[ORTTEXT].ob_flags |= HIDETREE;
		xobj = TRUE;
	}
	else
	{	info[ORTIME].ob_spec.index = 0x11000L;
		info[ORTIME].ob_type = G_IBOX;
		info[ORTIME].ob_state = 0;
		xobj = FALSE;
	}

	refm = set_refresh(SET_IT);
	info[OREFRESH].ob_spec.free_string = refmenu[refm];
}


/* Initialisiert Objektbaeume,  wird in cpx_init aufgerufen */
void InitGalaxy(void)
{	WORD i;

	calc();
	
	info = rs_trindex[OTINFO];
	
	/* damit Fenstergre gleich richtig gesetzt wird */
	dtree.ob_width = ((galx[ROOT].ob_width & 0x7) << 8)
						+ (galx[ROOT].ob_width >> 3);
	dtree.ob_height = ((galx[ROOT].ob_height & 0xf) << 8)
						+ (galx[ROOT].ob_height >> 4);
	cpxrsh_obfix(xcpb,&dtree,0);
	for ( i = 0; ; i++ )
	{	cpxrsh_obfix(xcpb,info,i);
		if ( info[i].ob_flags & LASTOB )
			break;
	}
}


/* Universelle Redrawroutine
		ist clip == NULL, wird als clip das GRECT des Wurzelobjekts verwendet */
void redraw( GRECT *clip, OBJECT *t, WORD obj )
{
	GRECT *win;
	
	if ( ! clip )
		clip = (GRECT*)&t[ROOT].ob_x;
	wind_update(BEG_UPDATE);
	win = cpxGetFirstRect(xcpb,clip);
	while (win)
	{	if ( win->g_w == 0 && win->g_h == 0 )
			break;
		objc_draw(t,obj,MAX_DEPTH,win->g_x,win->g_y,win->g_w,win->g_h);
		win = cpxGetNextRect(xcpb);
	}
	wind_update(END_UPDATE);
}


void top_window(void)
{	static WORD msg[8] = { WM_TOPPED, 0, 0, 0, 0, 0, 0, 0 };
	if (!bevent) return;
	msg[1] = apl_id;
	msg[3] = wdlg_get_handle(copsdialog);
	appl_write(apl_id,16,msg);
}
	

void _switch_redraw(OBJECT t[])
{
	WORD msg[8];
	
	msg[0] = WM_REDRAW; msg[1] = apl_id; msg[2] = 0;
	msg[3] = wdlg_get_handle(copsdialog);
	*((GRECT*)&msg[4]) = *((GRECT*)&t[ROOT].ob_x);
	appl_write(apl_id,16,msg);
}

GRECT rect;

void switch_to_info(void)
{	GRECT s;
	WORD x,y,w,h;
	
	wind_get(0,WF_WORKXYWH,&s.g_x,&s.g_y,&s.g_w,&s.g_h);
	x = galx[ROOT].ob_x;
	y = galx[ROOT].ob_y;
	w = info[OINFO].ob_width;
	h = info[OINFO].ob_height;
	rect = *(GRECT*)&galx[ROOT].ob_x;
	if ( x + w > s.g_x + s.g_w )   x = s.g_x + s.g_w - w;
	if ( x < s.g_x )	x = s.g_x;
	if ( y + h > s.g_y + s.g_h )   y = s.g_y + s.g_h - h;
	if ( y < s.g_y )    y = s.g_y;
	info[OINFO].ob_x = x;
	info[OINFO].ob_y = y;
	isinfodialog = TRUE;
	send_msg(SENDCPXET_UNSET,0,0,NULL);
	cpobjcpos(dtree,info[OINFO]);
	wdlg_set_size(copsdialog,(GRECT*)&info[OINFO].ob_x);
	_switch_redraw(info);
}


void switch_to_galaxy(void)
{
	*(GRECT*)&galx[ROOT].ob_x = rect;
	isinfodialog = FALSE;
	send_msg(SENDCPXET_SET,0,0,NULL);
	cpobjcpos(dtree,galx[ROOT]);
	wdlg_set_size(copsdialog,(GRECT*)&galx[ROOT].ob_x);
	_switch_redraw(galx);
}



/* Behandelt einen Mausklick auf einen Button, nur fuer info-Baum */
WORD button_click(WORD mode, WORD obj )
{	WORD x,y,b,i;
	
	if ( mode == 0 )
	{	info[obj].ob_state ^= SELECTED;
		redraw(NULL,info,obj);
	}
	for (;;)
	{	graf_mkstate(&x,&y,&b,&i);
		if ( ! (b & 3) )
		{	i = 1;
			break;
		}
		if ( obj != objc_find(info,OINFO,MAX_DEPTH,x,y) )
		{	i = 0;
			break;
		}
	}
	if ( mode == 0 )
	{	info[obj].ob_state ^= SELECTED;
		redraw(NULL,info,obj);
	}
	return i;
}
		
/* Zeigt Popup an, nur fuer info-Baum */
WORD Popup(WORD obj,char *menu[],WORD numitems,WORD start)
{	GRECT box;

	objc_offset(info,obj,&box.g_x,&box.g_y);
	box.g_w = info[obj].ob_width;
	box.g_h = info[obj].ob_height;
	return cpxPopup(xcpb,menu,numitems,start,IBM,&box,(GRECT*)&info[OINFO].ob_x);
}

/* Zeigt Popup an, nur fr galaxy-Baum */
WORD ePopup(char *menu[],WORD numitems,WORD start)
{	GRECT box;
	WORD i;

	graf_mkstate(&box.g_x,&box.g_y,&i,&i);
	i = strlen(menu[0]) * 8;
	box.g_x -= (i>>1);
	box.g_y -= 4;
	box.g_w = i;
	box.g_h = 8;
	return cpxPopup(xcpb,menu,numitems,start,IBM,&box,(GRECT*)&galx[ROOT].ob_x);
}



WORD set_refresh( WORD num )
{	static WORD tab[NUMREFRESH] = { 100,250,500,750,1000 };
	if ( num == SET_IT )
	{	WORD i;
		for ( i = 0; i < NUMREFRESH; i++ )
			if ( saveblk->time == (LONG)tab[i] )
				return i;
		return 0;
	}
	
	if ( num >= 0 && num < NUMREFRESH )
	{	refm = num;
		saveblk->time = (LONG)tab[num];
	}
	info[OREFRESH].ob_spec.free_string = refmenu[refm];
	set_evnt_mask();
	return refm;
}


void send_msg(WORD mode,WORD x,WORD y, char *s)
{	WORD msg[8+8+RAMSTRLEN/2+2], *mp;
	WORD xmsg_id, len, id;
	char *p;
	extern void *ram;
	extern WORD cram;
	
	if ( mode == SENDCPXET_SET || mode == SENDCPXET_UNSET )
	{	id = appl_find(CPXETIMER);
		if ( id < 0 ) return;
		msg[1] = apl_id;
		msg[2] = 0;
		msg[3] = wdlg_get_handle(copsdialog);
		msg[4] = msg[5] = msg[6] = msg[7] = 0;
		if ( mode == SENDCPXET_SET )
		{	msg[0] = CPXETIMER_SET;
			msg[4] = saveblk->time;
		}
		else msg[0] = CPXETIMER_UNSET;
		appl_write(id,16,msg);
		return;
	}
	
	if ( (xmsg_id = appl_find("XMSG    ")) < 0 )
	{
		if ( ram == NULL )
			return;
		if ( cram >= MAXSTR )  cram = 0;
		p = (char*)ram + RAMSTRLEN * cram;
	}
	else p = (char*)&msg[16];
	
	if ( mode == SENDBUBBLE )
	{	if ( (msg[3] = appl_find(BUBBLE)) < 0 )
			return;
		msg[4] = 5;
		msg[8] = BUBBLEGEM_SHOW;
		msg[11] = x;
		msg[12] = y;
		*(char**)&msg[13] = (xmsg_id >= 0 ? (char*)16L : p );
	}
	else
	{	if ( (msg[3] = appl_find(mode == SENDCOPS ? _COPS : STGUIDE)) < 0 )
			return;
		msg[4] = 3;
		msg[8] = VA_START;
		*(char**)&msg[11] = (xmsg_id >= 0 ? (char*)16L : p );
		msg[13] = 0;
		msg[14] = 0;
	}
	msg[10] = 0;
	msg[15] = 0;
	
	if ( xmsg_id >= 0 )
	{	len = 16 + 1 + strlen(s);
		if ( len > (RAMSTRLEN + 16) )
			len = RAMSTRLEN + 16;
		msg[0] = XMESSAGE;
		msg[1] = xmsg_id; /* Damit AV_STARTED etc. nicht an COPS gesendet wird */
		msg[2] = len;
		msg[5] = -1;
		msg[6] = 0;
		msg[7] = 0;
		msg[9] = xmsg_id;
		mp = msg;
	}
	else
	{	cram++;
		mp = &msg[8];
		len = 0;
		msg[9] = apl_id;
		xmsg_id = msg[3];
	}
	
	strncpy(p,s,RAMSTRLEN-1);
	p[RAMSTRLEN-1] = 0;
	appl_write(xmsg_id,16+len,mp);
}

