
/* XMSG: Message-Server

	#define XMESSAGE 0xfff0
	#define XMSG_ASK 0xfff1
	#define XMSG_OK  0xfff2
	
	msg[0] = XMESSAGE;
	msg[1] = AbsenderIdent;
	msg[2] = Lnge der Nachricht (16 + Lnge des Zusatzspeichers);
	msg[3] = ZielIdent;
	msg[4] = Index des 1. Zeigers oder -1
	msg[5] = Index des 2. Zeigers oder -1
	msg[6] = 0; reserviert
	msg[7] = 0; reserviert
	
	dieser Teil wird per appl_read gelesen:
	(Stellt eine normale Nachricht dar)
	b[0] = MessageId;
	b[1] = AbsenderIdent;
	b[2] = 0;
	b[3..7] = ...  (ein Zeiger wird als Offset ab &b[0] angegeben)
	BYTE buf[msg[2]-16]; zustzlicher Speicher

*/


#include <tm_start.h>
#include <tmstdlib.h>
#include <aes.h>
#include <mint_tos.h>
#include <string.h>

#include "xmsgrsc.h"
#include "rsh.h"
#include "proto.h"

#include "xmsg.h"


#ifdef DEBUG
void DEBUG_IT(char *s, ...)
{
	char buf[128];
	char fmt[128];
	va_list p;
	
	va_start(p,s);
	Vsprintf(buf,s,p);
	Sprintf(fmt,"[1][%s][ OK ]",buf);
	form_alert(1,fmt);
}
#undef DEBUG
#define DEBUG(_a_)  DEBUG_IT _a_  /* UNSAVE Macro !! */
#else
#undef DEBUG
#define DEBUG(_a_)
#endif



#define XMSGNAME "XMSG    "
#define XMSGMENUNAME "  XMSG  V 0.02"


char __rscid[] = "$Version: XMSG FREEWARE Testversion 0.02  06.03.97 by ToMST Thomas Maier $";

void Info(void)
{
	form_alert(1,"[1][   *** XMSG ***   |   Message-Server|  Testversion 0.02|"
				 " 06.03.97 by ToMST|  +++ FREEWARE +++][ OK ]");
}



#define STRINGLEN 256
#define MAXMSG 40
#define MAXZEIGER 3

#define BUFLEN ((LONG)MAXMSG * MAXZEIGER * STRINGLEN)

BYTE *buffer;
WORD aktmsg = 0;

WORD aplid;
WORD menuid;

OBJECT *menutree;

extern WORD _app;

struct
{
	struct multitoskonstanten
	{	unsigned ok : 1; /* ein AES >=4.00 ist vorhanden */
		unsigned applread_1 : 1; /* appl_read(-1,..) */
		unsigned apterm		: 1; /* Shutdown-Mglichkeit */
		unsigned search     : 1; /* appl_search vorhanden */
	}		mtos;
	WORD	aesversion;
}  AMc;

WORD sigexit = 0;


void sigh(LONG sig)
{
	switch ((WORD)sig)
	{
	 case SIGHUP:
	 case SIGINT:
	 case SIGQUIT:
	 case SIGTERM:
	 case SIGABRT:
	 case SIGXCPU:
	 				sigexit = 1;
	 				Psignal((WORD)sig,SIG_IGN);
	 				break;
	}
}

void signal_init(void)
{
	if ( Psignal(SIGTERM,sigh) != EINVFN )
	{	Psignal(SIGINT,sigh);
		Psignal(SIGQUIT,sigh);
		Psignal(SIGABRT,sigh);
		Psignal(SIGSYS,SIG_IGN);
		Psignal(SIGPIPE,SIG_IGN);
		Psignal(SIGALRM,SIG_IGN);
		Psignal(SIGHUP,sigh);
		Psignal(SIGURG,SIG_IGN);
		Psignal(SIGSTOP,SIG_IGN);
		Psignal(SIGTSTP,SIG_IGN);
		Psignal(SIGTTIN,SIG_IGN);
		Psignal(SIGTTOU,SIG_IGN);
		Psignal(SIGIO,SIG_IGN);
		Psignal(SIGXCPU,sigh);
		Psignal(SIGXFSZ,SIG_IGN);
		Psignal(SIGVTALRM,SIG_IGN);
		Psignal(SIGPROF,SIG_IGN);
		Psignal(SIGUSR1,SIG_IGN);
		Psignal(SIGUSR2,SIG_IGN);
		DEBUG(("Signal Init"));
	}
}


WORD InitMemory(void)
{
	if ( Get_cookie(asc2long('M','i','N','T'),NULL)
			|| Get_cookie(asc2long('M','a','g','X'),NULL) )
		buffer = Mxalloc(BUFLEN,0x20+3);
	else
		buffer = Malloc(BUFLEN);
	return (buffer != NULL);
}


void SendMsg(WORD to, WORD from, WORD msgnr, ... )
{	WORD msg[8];
	va_list p;

	va_start(p,msgnr);
	msg[0] = msgnr;
	msg[1] = from;
	msg[2] = 0;
	msg[3] = va_arg(p,WORD);
	msg[4] = va_arg(p,WORD);
	msg[5] = va_arg(p,WORD);
	msg[6] = va_arg(p,WORD);
	msg[7] = va_arg(p,WORD);
	
	appl_write(to,16,msg);
	DEBUG(("send msg 0x%hx to %hd",msgnr,to));
}



void mtosinit(void)
{	WORD w1,w2,w3,w4,i,magx;
	
	AMc.aesversion = global[0];
	AMc.mtos.ok = (global[0] >= 0x400 );
	magx = ( global[0] == 0x0399 && Get_cookie(asc2long('M','a','g','X'),NULL) );
	if ( magx || AMc.mtos.ok )
	{	i = appl_getinfo(4,&w1,&w2,&w3,&w4);
		AMc.mtos.search = ( i ? w3 != 0 : AMc.mtos.ok );
		i = appl_getinfo(6,&w1,&w2,&w3,&w4);
		AMc.mtos.applread_1 = ( i ? w1 != 0 : AMc.mtos.ok );
		i = appl_getinfo(10,&w1,&w2,&w3,&w4);
		AMc.mtos.apterm = ( i ? (w1 & 0xff)>=9 : AMc.mtos.ok );
	}
	DEBUG(("magx: %hd  mtos: %hd|search: %hd|read: %hd|apterm: %hd",
			magx,(WORD)AMc.mtos.ok,(WORD)AMc.mtos.search,
			(WORD)AMc.mtos.applread_1,(WORD)AMc.mtos.apterm));
	AMc.mtos.ok = ( AMc.mtos.ok || magx );
}


void cancel_msg_2( WORD msg[8] )
{	WORD tmp[STRINGLEN], i;

	if ( msg == NULL ) return;
	while (msg[2] > 0 )
	{	if ( msg[2] > STRINGLEN ) i = STRINGLEN; else i = msg[2];
		msg[2] -= i;
		if ( !appl_read((AMc.mtos.applread_1 ? -1 : aplid),i,tmp) )
			msg[2] = 0;
	}
}


void cancel_dragdrop(WORD msg[8])
{	static char pipename[] = "U:\\PIPE\\DRAGDROP.AA";
	LONG fd;
	register char *mem = (char *)&msg[7];
	BYTE c;
	
#define DD_NAK 1

	pipename[17] = *mem++;
	pipename[18] = *mem;
	fd = Fopen(pipename,O_RDWR);
	if ( fd > 0 )
	{	c = DD_NAK;
		Fwrite((WORD)fd,1L,&c);
		Fclose((WORD)fd);
	}
}



void Exit(WORD ok)
{
	DEBUG(("EXIT IT  aplid=%hd",aplid));
	if ( buffer )
		Mfree(buffer);
	if ( _app || AMc.mtos.ok)
	{	if (menutree)
			menu_bar(menutree,0);
		appl_exit();
		exit(ok);
	}
	for (;;)
	{	WORD msg[8];
		evnt_mesag(msg);
		cancel_msg_2(msg);
	}
}



void is_running(void)
{
	char buf[16];
	WORD id,a,k;
	
	if ( ! AMc.mtos.search )
		return;
	DEBUG(("test if running"));
	k = 0;
	while ( appl_search(k,buf,&a,&id) )
	{	k = 1;
		if ( id == aplid )
			continue;
		if ( strncmp(buf,XMSGNAME,4) == 0 )
			Exit(2);
	}
}


void main(void)
{
	WORD ret;
	
	menutree = NULL;
	buffer = NULL;
	
	ret = InitMemory();
	
	aplid = appl_init();
	DEBUG(("aplid = %hd",aplid));
	mtosinit();
	if ( _app || AMc.mtos.ok )
		signal_init();
	
	is_running();
	
	if ( ret == 0 )
	{	form_alert(1,"[3][  XMSG:         | Zuwenig Speicher!][ Abbruch ]");
		Exit(1);
	}
	
	menuid = (AMc.mtos.ok || !_app) ?
				menu_register(aplid,XMSGMENUNAME) : -1;
	if ( AMc.mtos.apterm )
		shel_write(9,1,0,NULL,NULL);
	if ( _app )
	{	WORD i;
		menutree = rs_trindex[OTMENU];
		for ( i = 0; i < NUM_OBJS; i++ )
			rsrc_obfix(menutree,i);
		menu_bar(menutree,1);	
		graf_mouse(ARROW,NULL);
	}
	
	ProcessIt();
	
	Exit(0);
}


void ProcessIt(void)
{
	static WORD msg[8];
	WORD len,i,k;
	WORD *base;
	static MEVENT evnt = { MU_TIMER|MU_MESAG,0,0,0,0,{0,0,0,0},0,{0,0,0,0},
					 		msg,1000L };
	
	for (;;)
	{
		k = evnt_event(&evnt);
		if ( k & MU_TIMER )
		{	if ( sigexit )
			{	DEBUG(("Signal Exit"));
				Exit(0);
			}
		}
		if ( k & MU_MESAG )
		{
			if ( msg[0] != XMESSAGE )
				cancel_msg_2(msg);
			switch ( msg[0] )
			{
			 case XMSG_ASK:	DEBUG(("XMSG_ASK"));
			 				SendMsg(msg[1],aplid,XMSG_OK,0,0L,0L);
			 				break;
			 
			 case XMESSAGE: DEBUG(("XMESSAGE"));
			 				if ( msg[2] < 16 )
			 					break;
			 				len = msg[2];
		 					i = len / STRINGLEN;
		 					if ( aktmsg + i >= MAXMSG )
		 						aktmsg = 0;
		 					base = (WORD*)((ULONG)buffer + ((ULONG)aktmsg * STRINGLEN));
		 					aktmsg += (i + 1);
		 					DEBUG(("read %hd Bytes|Pufferanzahl %hd",len,i+1));
		 					if ( appl_read(aplid,len,(void*)base) )
		 					{	
		 						if ( len > 16 )
		 						{	
		 							for ( i = 4; i < 6; i++ )
		 							{	k = msg[i];
		 								if ( k > 2 && k < 7 )
		 								{	if ( base[k+1] >= 16 && base[k+1] < len)
		 									{	*(LONG*)&base[k] = (LONG)base +
		 															(LONG)base[k+1];
		 										DEBUG(("Passe Zeiger an msg %hd",k));
		 									}
		 									else break;
		 								}
		 							}
		 							if ( i != 6 ) break;
		 						}
		 						else
		 							if ( msg[4] != -1 || msg[5] != -1 )
		 								break;
		 						
			 					SendMsg(msg[3],msg[1],base[0],base[3],base[4],base[5],
			 															base[6],base[7]);
			 				}
			 				break;
			 
			 case AP_TERM:	if (_app) Exit(0); break;
			 
			 case AC_OPEN:	if ( !_app ) Info(); break;
			 
			 case MN_SELECTED:
			 				if ( _app )
			 				{
			 					switch ( msg[4] )
			 					{
			 					 case OINFO:	Info(); break;
			 					 case OQUIT:	Exit(0); break;
			 					}
			 					menu_tnormal(menutree,msg[3],1);
			 				}
			 				break;
			
			 case AP_DRAGDROP:	cancel_dragdrop(msg); break;
			}
		}
	}
}

